plugins/Reports/config/routes.php
<?php
use Cake\Routing\RouteBuilder;
use Cake\Routing\Router;
use Cake\Routing\Route\DashedRoute;

Router::plugin(
    'Reports',
    ['path' => '/reports'],
    function (RouteBuilder $routes) {
        $routes->setExtensions(['pdf']);

        $routes->fallbacks(DashedRoute::class);
    }
);

plugins/Reports/src/Model/Table/OccurrencesTable.php
<?php
namespace Reports\Model\Table;

use Cake\Chronos\Chronos;
use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Occurrences Model
 *
 * @property \Reports\Model\Table\UsersTable|\Cake\ORM\Association\BelongsTo $Users
 * @property \Reports\Model\Table\SectorsTable|\Cake\ORM\Association\BelongsTo $Sectors
 * @property \Reports\Model\Table\StatusTable|\Cake\ORM\Association\BelongsTo $Status
 * @property \Reports\Model\Table\CategoriesTable|\Cake\ORM\Association\BelongsTo $Categories
 *
 * @method \Reports\Model\Entity\Occurrence get($primaryKey, $options = [])
 * @method \Reports\Model\Entity\Occurrence newEntity($data = null, array $options = [])
 * @method \Reports\Model\Entity\Occurrence[] newEntities(array $data, array $options = [])
 * @method \Reports\Model\Entity\Occurrence|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \Reports\Model\Entity\Occurrence patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \Reports\Model\Entity\Occurrence[] patchEntities($entities, array $data, array $options = [])
 * @method \Reports\Model\Entity\Occurrence findOrCreate($search, callable $callback = null, $options = [])
 *
 * @mixin \Cake\ORM\Behavior\TimestampBehavior
 */
class OccurrencesTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('occurrences');
        $this->setDisplayField('title');
        $this->setPrimaryKey('id');

        $this->addBehavior('Timestamp');
        $this->addBehavior('Search.Search');

        $this->belongsTo('Users', [
            'foreignKey' => 'user_id',
            'joinType' => 'INNER',
            'className' => 'Reports.Users'
        ]);
        $this->belongsTo('Sectors', [
            'foreignKey' => 'sector_id',
            'joinType' => 'INNER',
            'className' => 'Reports.Sectors'
        ]);
        $this->belongsTo('Status', [
            'foreignKey' => 'status_id',
            'joinType' => 'INNER',
            'className' => 'Reports.Status'
        ]);
        $this->belongsTo('Categories', [
            'foreignKey' => 'category_id',
            'joinType' => 'INNER',
            'className' => 'Reports.Categories'
        ]);

        $this->searchManager()
            ->add('from', 'Search.Callback', [
                'callback' => function ($query, $args, $manager) {
                    $values = explode(' ', trim($args['from']));
                    foreach ($values as $value) {
                        $value = str_replace('/', '-', $value);
                        $value = date('Y-m-d', strtotime($value));
                        $query->where(["Occurrences.created >=" => "$value"]);
                    }
                }
            ])
            ->add('to', 'Search.Callback', [
                'callback' => function ($query, $args, $manager) {
                    $values = explode(' ', trim($args['to']));
                    foreach ($values as $value) {
                        $value = str_replace('/', '-', $value);
                        $value = date('Y-m-d', strtotime($value));
                        $date = Chronos::createFromFormat('Y-m-d', $value);
                        $to = $date->addDay();
                        $query->where(["Occurrences.created <=" => "$to"]);
                    }
                }
            ])
            ->add('sector_id', 'Search.Callback', [
                'callback' => function ($query, $args, $manager) {
                    $query->where(["Occurrences.sector_id IN" => $args['sector_id']]);
                }
            ])
            ->add('category_id', 'Search.Callback', [
                'callback' => function ($query, $args, $manager) {
                    $query->where(["Occurrences.category_id IN" => $args['category_id']]);
                }
            ])
            ->add('status_id', 'Search.Callback', [
                'callback' => function ($query, $args, $manager) {
                    $query->where(["Occurrences.status_id IN" => $args['status_id']]);
                }
            ]);
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->uuid('id')
            ->allowEmpty('id', 'create');

        $validator
            ->scalar('title')
            ->maxLength('title', 255)
            ->requirePresence('title', 'create')
            ->notEmpty('title');

        $validator
            ->scalar('description')
            ->allowEmpty('description');

        $validator
            ->scalar('locale')
            ->maxLength('locale', 255)
            ->allowEmpty('locale');

        $validator
            ->scalar('image')
            ->maxLength('image', 255)
            ->requirePresence('image', 'create')
            ->notEmpty('image');

        $validator
            ->scalar('observations')
            ->allowEmpty('observations');

        return $validator;
    }
}

plugins/Reports/src/Controller/PdfController.php
<?php
namespace Reports\Controller;

use Cake\Chronos\Chronos;
use Cake\Core\Configure;

/**
 * Alone Controller
 */
class PdfController extends Reports
{
    public $helpers = ['Dompdf.Dompdf'];

    public function initialize()
    {
        parent::initialize();
        $this->loadComponent('Paginator');
        $this->loadComponent('Reports.PrintReport');
        $this->loadModel('Reports.Occurrences');
    }

    /**
     * Alone method
     *
     * Print only a occurrence
     *
     * @return \Cake\Http\Response|void
     */
    public function alone($id)
    {
        $occurrence = $this->Occurrences->get($id, [
            'contain' => ['Sectors', 'Status', 'Categories', 'Users']
        ]);

        $this->set(compact('occurrence'));
        $this->set('userAuth', $this->Auth->user());

        $this->setTemplate('alone');
        $this->PrintReport->printOut($id);
    }

    /**
     * Alone method
     *
     * Print occurrences
     *
     * @return \Cake\Http\Response|void
     */
    public function occurrences()
    {
        $session = $this->request->getSession();
        $params = $session->read('ReportsParams');

        $occurrences = $this->Occurrences->find('all', [
            'contain' => ['Sectors', 'Status', 'Categories', 'Users']
        ]);

        if (isset($params)) {
            if (isset($params['sector_id'])) {
                $occurrences->where(['sector_id IN' => $params['sector_id']]);
            }

            if (isset($params['category_id'])) {
                $occurrences->where(['category_id IN' => $params['category_id']]);
            }

            if (isset($params['status_id'])) {
                $occurrences->where(['status_id IN' => $params['status_id']]);
            }

            if (isset($params['from'])) {
                $from = str_replace('/', '-', $params['from']);
                $from = date('Y-m-d', strtotime($from));
                $occurrences->where(["Occurrences.created >=" => "$from"]);
            }

            if (isset($params['to'])) {
                $value = str_replace('/', '-', $params['to']);
                $value = date('Y-m-d', strtotime($value));
                $date = Chronos::createFromFormat('Y-m-d', $value);
                $to = $date->addDay();
                $occurrences->where(["Occurrences.created <=" => "$to"]);
            }
        }

        $occurrences->orderDesc('Occurrences.created');

        $this->set(compact('occurrences'));
        $this->set('userAuth', $this->Auth->user());

        $this->setTemplate('occurrences');
        $this->PrintReport->printOut();
    }
}

plugins/Reports/src/Template/Pdf/alone.ctp
<?= $this->layout = false; ?>
<?php $this->response->type('pdf'); ?>
<?= $this->Dompdf->css('materialize'); ?>
<?= $this->Dompdf->css('custom'); ?>
<h5 class="center"><?= __('SGInfra - Sistema de Gerenciamento da Infraestrutura') ?></h5>
<table class="striped">
    <thead>
        <tr>
            <th><?= __d('reports', 'User') ?></th>
            <th><?= __d('reports', 'Title') ?></th>
            <th><?= __d('reports', 'Locale') ?></th>
            <th><?= __d('reports', 'Sector') ?></th>
            <th><?= __d('reports', 'Status') ?></th>
            <th><?= __d('reports', 'Category') ?></th>
            <th><?= __d('reports', 'Created') ?></th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td><?= $occurrence->user->name ?></td>
            <td><?= $occurrence->title ?></td>
            <td><?= $occurrence->locale ?></td>
            <td><?= $occurrence->sector->name ?></td>
            <td><?= $occurrence->status->name ?></td>
            <td><?= $occurrence->category->name ?></td>
            <td><?= $occurrence->created->format('d/m/Y H:i:s') ?></td>
        </tr>
    </tbody>
</table>
<br><br>
<footer>
    <h6><?= __d('reports', '<b>Issuer:</b> {0}', $userAuth->name) ?></h6>
    <h6><?= __d('reports', '<b>Date of issue:</b> {0}', date('d/m/Y H:i:s')) ?></h6>
</footer>

plugins/Reports/src/Template/Pdf/occurrences.ctp
<?= $this->layout = false; ?>
<?php $this->response->type('pdf'); ?>
<?= $this->Dompdf->css('materialize'); ?>
<?= $this->Dompdf->css('custom'); ?>
<h5 class="center"><?= __('SGInfra - Sistema de Gerenciamento da Infraestrutura') ?></h5>
<table class="striped">
    <thead>
    <tr>
        <th><?= __d('reports', 'User') ?></th>
        <th><?= __d('reports', 'Title') ?></th>
        <th><?= __d('reports', 'Locale') ?></th>
        <th><?= __d('reports', 'Sector') ?></th>
        <th><?= __d('reports', 'Status') ?></th>
        <th><?= __d('reports', 'Category') ?></th>
        <th><?= __d('reports', 'Created') ?></th>
    </tr>
    </thead>
    <tbody>
    <?php foreach ($occurrences as $occurrence): ?>
        <tr>
            <td><?= $occurrence->user->name ?></td>
            <td><?= $occurrence->title ?></td>
            <td><?= $occurrence->locale ?></td>
            <td><?= $occurrence->sector->name ?></td>
            <td><?= $occurrence->status->name ?></td>
            <td><?= $occurrence->category->name ?></td>
            <td><?= $occurrence->created->format('d/m/Y H:i:s') ?></td>
        </tr>
    <?php endforeach; ?>
    </tbody>
</table>
<br><br>
<footer>
    <h6><?= __d('reports', '<b>Issuer:</b> {0}', $userAuth->name) ?></h6>
    <h6><?= __d('reports', '<b>Date of issue:</b> {0}', date('d/m/Y H:i:s')) ?></h6>
</footer>